//***************************************************************
//                   HEADER FILES
//***************************************************************


#include<iostream>
#include<cstdio>
#include<cstring>
#include<fstream>
#include<process.h>

using namespace std;


//***************************************************************
//                   CLASSES USED
//****************************************************************



class book
{
	int bno;
	string bname;
	string aname;
  public:
	void create_book()
	{
		cout<<"\nNEW BOOK ENTRY...\n";
		cout<<"\nEnter The book no.";
		cin>>bno;
		cout<<"\n\nEnter The Name of The Book ";
		cin>>bname;
		cout<<"\n\nEnter The Author's Name ";
		cin>>aname;
		cout<<"\n\n\nBook Created..";
	}

	void show_book()
	{
		cout<<"\nBook no. : "<<bno;
		cout<<"\nBook Name : ";
		cin>>bname;
		cout<<"Author Name : ";
		cin>>aname;
	}

	void modify_book()
	{
		cout<<"\nBook no. : "<<bno;
		cout<<"\nModify Book Name : ";
		cin>>bname;
		cout<<"\nModify Author's Name of Book : ";
		cin>>aname;
	}

	int retbno()
	{
		return bno;
	}

	string retbname()
	{

	    return bname;
	}

	string retaname()
	{

	    return aname;
	}

	void report()
	{
	    cout<<bno<<"\t"<<bname<<"\t"<<aname<<endl;
    }


};




class student
{
	int admno;
	string name;
	int stbno;
	int flag;
public:
	void create_student()
	{
	 	cout<<"\nNEW STUDENT ENTRY...\n";
		cout<<"\nEnter The admission no. ";
		cin>>admno;
		cout<<"\n\nEnter The Name of The Student ";
		cin>>name;
		cout<<"\n\nStudent Record Created..";
	}

	void show_student()
	{
		cout<<"\nAdmission no. : "<<admno;
		cout<<"\nStudent Name : ";
		cin>>name;
		cout<<"\nNo of Books issued : "<<flag;
		if(flag==1)
        cout<<"\nBook No "<<stbno;
	}

	void modify_student()
	{
		cout<<"\nAdmission no. : "<<admno;
		cout<<"\nModify Student Name : ";
		cin>>name;
	}

	int retadmno()
	{
		return admno;
	}

	string retname()
	{

	    return name;
	}

	int retstbno()
	{
		return stbno;
	}

	int retflag()
	{
		return flag;
	}

	void add_flag()
	{flag=1;}

	void reset_flag()
	{flag=0;}

	void get_stbno( int b)
	{
		stbno=b;
	}

	void report()
	{cout<<"\t"<<admno<<"\t"<<name<<"\t"<<flag<<endl;}

};




book bk;
student st;



void write_book()
{
    ofstream fp;
	char ch;
	fp.open("book");
	do
	{
		bk.create_book();
		ofstream out("book",ofstream::app);
		out<<bk.retbno()<<"\t"<<bk.retbname()<<"\t"<<bk.retaname()<<endl;
		cout<<"\n\nDo you want to add more record..(y/n?)";
		cin>>ch;
	}while(ch=='y'||ch=='Y');
	fp.close();
}



void write_student()
{
    ofstream fp;
	char ch;
	fp.open("student");

	do
	{
		st.create_student();
		ofstream out("student",ofstream::app);
		out<<st.retadmno()<<"\t"<<st.retname()<<endl;
		cout<<"\n\ndo you want to add more record..(y/n?)";
		cin>>ch;
	}while(ch=='y'||ch=='Y');
	fp.close();
}




int display_spb(int n)
{
    cout<<"BOOK DETAIL\n\n";
    ifstream fp;
    fp.open("book");
    int bno,flag=0;
    string bname,aname;
    while(fp>>bno>>bname>>aname)
    {
      if(bno==n)
      {
          cout<<bno<<"\t"<<bname<<"\t"<<aname<<endl;
          flag=1;
          break;
      }
    }
   if(flag==0)
   {
       cout<<"Book does not exist\n";
       return 1;
   }
	fp.close();
}

int display_sps(int n)
{
	cout<<"\nSTUDENT DETAIL\n\n";
	ifstream fp;
    fp.open("student");
    int admno,flag=0;
    string name;
    while(fp>>admno>>name)
    {
      if(admno==n)
      {
          cout<<admno<<"\t"<<name<<endl;
          flag=1;
          break;
      }
    }
    if(flag==0)
    {
        cout<<"Student record does not exist\n";
        return 1;
    }

	fp.close();
}



void display_alls()
{
    ifstream in;
    in.open("student");
    int admno;
    string name;
	cout<<"\n\n\t\tSTUDENT LIST\n\n";
	cout<<"==================================================================\n";
	cout<<"\tAdmission No."<<"\t\t"<<"Name\n\n";
	cout<<"==================================================================\n";

	while(in>>admno>>name)
    {
        cout<<"\t"<<admno<<"\t\t"<<name<<endl;
    }

    in.close();

}


void display_allb()
{
    ifstream in;
    in.open("book");
    int bno;
    string bname,aname;

    cout<<"\n\n\t\tBook LIST\n\n";
	cout<<"=========================================================================\n";
	cout<<"Book Number"<<"\t\t"<<"Book Name"<<"\t\t"<<"Author\n\n";
	cout<<"=========================================================================\n";

	while(in>>bno>>bname>>aname)
    {
        cout<<"\t"<<bno<<"\t"<<bname<<"\t"<<aname<<endl;
    }

    in.close();

}



void delete_book()
{
	int bno,n;
	string bname,aname;
	cout<<"\n\n\n\tDELETE BOOK ...";
	cout<<"\n\nEnter The Book no. of the Book You Want To Delete : ";
	cin>>n;
	ifstream fp1,in;
	ofstream fp2,out;

	fp1.open("book");
	fp2.open("temp1");

	while(fp1>>bno>>bname>>aname)
    {
        if(bno==n)
        {
            //nothing
        }
        else
        {
            fp2<<bno<<"\t"<<bname<<"\t"<<aname<<endl;
        }
    }

	in.open("temp1");
	out.open("book");
	while(in>>bno>>bname>>aname)
    {
        out<<bno<<"\t"<<bname<<"\t"<<aname<<endl;
    }

    fp1.close();
    fp2.close();
    in.close();
    out.close();
}



void delete_student()
{
    int admno,n;
    string name;
    cout<<"\n\n\n\tDELETE STUDENT...";
    cout<<"\n\nEnter The admission no. of the Student You Want To Delete : ";
    cin>>n;
    ifstream fp1,in;
    ofstream fp2,out;

    fp1.open("student");
    fp1.open("temp2");

    while(fp1>>admno>>name)
    {
        if(admno==n)
        {
            //nothing
        }
        else
        {
            fp2<<admno<<"\t"<<name<<endl;
        }
    }

    in.open("temp1");
    out.open("student");

    while(in>>admno>>name)
    {
        out<<admno<<"\t"<<name<<endl;
    }

    fp1.close();
    fp2.close();
    in.close();
    out.close();
}




int book_issue()
{

    ifstream fp1,fp2,fp3;
    ofstream fp;
    fp1.open("book");
    fp2.open("student");
    fp.open("record",ofstream::app);
    fp3.open("record");
    int bno,admno,n,m,flag1=0,flag2=0,flag3=0;
    string bname,aname,name;
    cout<<"\n\tEnter the book id which student wants to issue:";
    cin>>m;
    while(fp1>>bno>>bname>>aname)
    {
        if(m==bno)
         {
             fp<<bno<<"\t"<<bname<<"\t"<<aname;
             flag1=1;
             break;
         }

    }
    if(flag1==0)
    {
     cout<<"Book does not exist\n";
     return 1;
    }

    while(fp3>>bno>>bname>>aname>>admno>>name)
    {
        if(bno==m)
        {
            cout<<"Book already issued\n";
            flag3=1;
            break;
        }
    }
    if(flag3==1)
    {
        return 1;
    }

    cout<<"\n\tEnter the admission no of student:";
    cin>>n;
    while(fp2>>admno>>name)
    {
        if(admno==n)
        {
            fp<<"\t\t"<<admno<<"\t\t"<<name;
            flag2=1;
            break;
        }
    }
    if(flag2==0)
    {
        cout<<"\nStudent record does not exist\n";
    }

    fp.close();
    fp1.close();
    fp2.close();

}



void book_deposit()
{
    int bno,admno,n;
    string bname,aname,name;
    ifstream fp1,in;
    ofstream fp2,out;
    cout<<"\n\nEnter The Book no. of the Book You Want To Deposit : ";
	cin>>n;
    fp1.open("record");
    fp2.open("temp");
    while(fp1>>bno>>bname>>aname>>admno>>name)
    {
        if(bno==n)
        {
            //nothing
        }
        else
        {
            fp2<<bno<<"\t"<<bname<<"\t"<<aname<<"\t"<<admno<<"\t"<<name<<endl;
        }
    }
    in.open("temp1");
	out.open("record");
	while(in>>bno>>bname>>aname>>admno>>name)
    {
        out<<bno<<"\t"<<bname<<"\t"<<aname<<"\t"<<admno<<"\t"<<name<<endl;
    }

    fp1.close();
    fp2.close();
    in.close();
    out.close();

}



void display()
{
  int bno,admno;
  string bname,aname,name;
  ifstream in;
  in.open("record");

  cout<<"\n\n\t\tRECORD\n\n";
  cout<<"=========================================================================\n";
  cout<<"Book Number"<<"\t"<<"Book Name"<<"\t"<<"Student id"<<"\t"<<"Student name\n";
  cout<<"=========================================================================\n";
  while(in>>bno>>bname>>aname>>admno>>name)
  {
      cout<<bno<<"\t"<<bname<<"\t"<<admno<<"\t"<<name<<endl;
  }
  in.close();
}


void admin_menu()
{
	int ch2;

	cout<<"\n\n\n\tADMINISTRATOR MENU";

	cout<<"\n\n\t1.CREATE STUDENT RECORD";

	cout<<"\n\n\t2.DISPLAY ALL STUDENTS RECORD";

	cout<<"\n\n\t3.DISPLAY SPECIFIC STUDENT RECORD ";

	cout<<"\n\n\t4.DELETE STUDENT RECORD";

	cout<<"\n\n\t5.CREATE BOOK ";

	cout<<"\n\n\t6.DISPLAY ALL BOOKS ";

	cout<<"\n\n\t7.DISPLAY SPECIFIC BOOK ";

	cout<<"\n\n\t8.DELETE BOOK ";

    cout<<"\n\n\t9.DISPLAY RECORD(issued books)";

    cout<<"\n\n\t10.BACK TO MAIN MENU";

	cout<<"\n\n\tPlease Enter Your Choice (1-10) ";

	cin>>ch2;

	switch(ch2)
	{   case 1:
            write_student();
            break;
        case 2: display_alls();
                break;
        case 3: {
	       		int num;
	       		cout<<"\n\n\tPlease Enter The Admission No. ";
	       		cin>>num;
	       		display_sps(num);
	       		break;
               }
        case 4: delete_student();
                break;
		case 5:
			    write_book();
                break;
        case 6: display_allb();
                break;
		case 7: {
	       		int num;
	       		cout<<"\n\n\tPlease Enter The book No. ";
	       		cin>>num;
	       		display_spb(num);
	       		break;
			    }
		case 8: delete_book();
		         break;
		case 9: display();
		         break;
        case 10: return;
        default:cout<<"\a";
   	}

   	admin_menu();
}



int main()
{
	char ch;
	do
	{
		cout<<"\n\n\n\tMAIN MENU";

		cout<<"\n\n\t01. BOOK ISSUE";

		cout<<"\n\n\t02. BOOK DEPOSIT";

	  	cout<<"\n\n\t03. ADMINISTRATOR MENU";

	  	cout<<"\n\n\t04. EXIT";

	  	cout<<"\n\n\tPlease Select Your Option (1-4) ";

	  	cin>>ch;

	  	switch(ch)
	  	{
	  	    case '1':
				 book_issue();
			   	 break;
			case '2':
                 book_deposit();
		  	case '3':
                 admin_menu();
				 break;
		  	case '4':return(0);
		  	default :cout<<"\a";
		}
    	}while(ch!='4');
}
